<template>
  <v-container>
    <v-data-table
        :headers="headers"
        :items="sessions"
    >
      <template v-slot:item.actions="{ item }">
        <v-icon small class="mr-3" @click="startSession(item)">
          left fa fa-play
        </v-icon>
        <v-icon small class="mr-2" @click="editSession(item)">
          fa-pencil-alt
        </v-icon>
      </template>
    </v-data-table>
  </v-container>

</template>

<script lang="ts">
import {Component, Vue} from "vue-property-decorator";
import {sessionApi} from "@/api/sessionApi";
import {signalRIdentifiers} from "@/store/modules/signalR";
import {Session} from "@/models/session";
import router from "@/router/index";

@Component
export default class SessionList extends Vue {
  headers = [
    {
      text: "Titel",
      value: "title",
      sortable: true,
    },
    {
      text: "Teilnahme-Code",
      value: "accessCode",
      sortable: false,
      align: 'center',
    },
    {
      text: "Aktionen",
      value: 'actions',
      sortable: false
    }
  ];
  sessions: Session[] = [];

  created() {
    sessionApi.getUserSessions()
        .then(sessions => {

          this.sessions = sessions;
        })
  }
    
    startSession(session: Session) {
      this.$store.dispatch(signalRIdentifiers.actions.startSession, session.id);
    }

  editSession(session: Session) {
    router.push({name: 'edit session', query: {sessionId: session.id}});
  }
}

</script>

<style scoped>

</style>